unit DlgShowHdaIntf;

interface

uses
  Windows, Messages, SysUtils,
  Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, ComCtrls, dOPCHDA;

type
  THdaIntfDlg = class(TForm)
    ListView1: TListView;
    Panel1: TPanel;
    Button1: TButton;
    procedure ListView1CustomDrawSubItem(Sender: TCustomListView;
      Item: TListItem; SubItem: Integer; State: TCustomDrawState;
      var DefaultDraw: Boolean);
    procedure FormShow(Sender: TObject);
  private
    HDAServer : TdOPCHDaServer;
  public
  end;


  procedure ShowHDAInterfaces(HDAServer : TdOPCHDAServer);

implementation

{$R *.dfm}

procedure ShowHDAInterfaces(HDAServer : TdOPCHDAServer);
var
  D : THdaIntfDlg;
begin
  Application.CreateForm(THdaIntfDlg,D);
  D.HDAServer := HdaServer;
  D.ShowModal;
  D.Free;
end;

procedure ShowInterfaces(HdaServer: TdOPCHDAServer; Listview: TListview);
var
  S : TdOPCHDAServer;

  // adds a item to listview
  procedure AddItemToList(Field1, Field2, Field3: string; Field4: string = '');
  var
    Item   : TListItem;
  begin
    Item := ListView.Items.Add;
    Item.ImageIndex := -1;
    Item.Caption := Field1;
    Item.SubItems.Add(Field2);
    if Field3 <> '' then
      Item.SubItems.Add(Field3);
    if Field4 <> '' then
      Item.SubItems.Add(Field4);
  end;


  function Exists(checked: boolean): string;
  begin
    result := '-';
    if checked then
      result := '*';
  end;

begin
  S := HdaServer;
  ListView.Items.BeginUpdate;
  try
    AddItemToList('Read','','');
    AddItemToList('  ReadRaw',      ' ',Exists(srRaw in S.capsSyncRead), Exists(arRaw in S.capsAsyncRead) );
    AddItemToList('  ReadAttribute',' ',Exists(srAttribute in S.capsSyncRead ), Exists(arAttribute in S.capsAsyncRead) );
    AddItemToList('  ReadProcessed','*',Exists(srProcessed in S.capsSyncRead), Exists(arProcessed in S.capsAsyncRead) );
    AddItemToList('  ReadAtTime',   '*',Exists(srAtTime in S.capsSyncRead), Exists(arAtTime in S.capsAsyncRead ) );
    AddItemToList('  ReadModified', '*',Exists(srModified in S.capsSyncRead), Exists(arModified in S.capsAsyncRead) );
    AddItemToList('  AdviseRaw',    '*','none', Exists(arAdviseRaw in S.capsAsyncRead) );
    AddItemToList('','','');
    AddItemToList('Update','*','');
    AddItemToList('  Insert',       '*',Exists(suInsert in S.capsSyncUpdate), Exists(auInsert in S.capsAsyncUpdate) );
    AddItemToList('  Replace',      '*',Exists(suReplace in S.capsSyncUpdate ), Exists(auReplace in S.capsAsyncUpdate ) );
    AddItemToList('  InsertReplace','*',Exists(suInsertReplace in S.capsSyncUpdate), Exists(auInsertReplace in S.capsAsyncUpdate) );
    AddItemToList('  DeleteRaw',    '*',Exists(suDeleteRaw in S.capsSyncUpdate ), Exists(auDeleteRaw in S.capsAsyncUpdate ) );
    AddItemToList('  DeleteAtTime', '*',Exists(suDeleteAtTime in S.capsSyncUpdate ), Exists(auDeleteAtTime in S.capsAsyncUpdate) );
    AddItemToList('','','');
    AddItemToList('Annotations','*','');
    AddItemToList('  Read',         ' ',Exists(saRead in S.capsSyncAnnotations), Exists(aaRead in S.capsAsyncAnnotations) );
    AddItemToList('  Insert',       '*',Exists(saInsert in S.capsSyncAnnotations), Exists(aaInsert in S.capsAsyncAnnotations) );
    AddItemToList('','','');
    AddItemToList('PlayBack','*','');
    AddItemToList('  ReadRawWithUpdate', ' ',Exists(pbRaw in S.capsPlayback),'none');
    AddItemToList('  ReadProcessedWithU.','*',Exists(pbProcessed in S.capsPlayback),'none');
  finally
    ListView.Items.EndUpdate;
  end;
end;


procedure THdaIntfDlg.ListView1CustomDrawSubItem(Sender: TCustomListView;
  Item: TListItem; SubItem: Integer; State: TCustomDrawState;
  var DefaultDraw: Boolean);
begin
  Sender.Canvas.Brush.Color := clWindow;
  if Subitem > 1 then
    if Subitem <= Item.SubItems.Count then
    begin
      if Item.SubItems[Subitem-1] = '*' then
        Sender.Canvas.Brush.Color := clGreen
      else
      if Item.SubItems[Subitem-1] = '-' then
       Sender.Canvas.Brush.Color := clRed
       else
         DefaultDraw := false;
    end;
end;

procedure THdaIntfDlg.FormShow(Sender: TObject);
begin
  ShowInterfaces(HdaServer, Listview1);
end;

end.
