unit dOPCDlgServerStatus;

interface

uses
  Windows, Messages, SysUtils,  Classes, Graphics, Controls, Forms,

  Dialogs, StdCtrls, ComCtrls, ExtCtrls, dOPCComn, dOPCIntf, dOPCHDA;

type
  TdOPCServerStatusForm = class(TForm)
    Panel1: TPanel;
    ListView: TListView;
    bClose: TButton;
    bUpdate: TButton;
    procedure FormShow(Sender: TObject);
    procedure bUpdateClick(Sender: TObject);
  private
    OPCClient : TdOPCClient;
    procedure AddItemToList(Field1, Field2: string);
  public
    procedure UpdateStatus;
  end;

  procedure dOPCShowServerStatus(OPCServer : TdOPCClient);

implementation
{$R *.dfm}

procedure dOPCShowServerStatus(OPCServer : TdOPCClient);
var
  D : TdOPCServerStatusForm;
begin
  Application.CreateForm(TdOPCServerStatusForm,D);
  try
    D.OPCClient := OPCServer;
    D.ShowModal;
  finally
    D.Free;
  end;
end;


// this methods set the width of listview columns
procedure SetColumnWidth(ListView : TListView);
var
  i,c : integer;
  V : string;
  MaxWidth : integer;
  W : integer;
begin
  for c := 0 to ListView.Columns.Count-1 do    // for all columns
  begin
    MaxWidth := ListView.StringWidth(ListView.Columns[c].Caption);
    for i := 0 to ListView.Items.Count-1 do
    begin
       V := '';
       if c = 0 then
         V := ListView.Items[i].Caption
       else
         if ListView.Items[i].SubItems.Count >= c then
           V := ListView.Items[i].SubItems[c-1];
       if V <> '' then
       begin
         W := ListView.StringWidth(V);
         if W > MaxWidth then
           MaxWidth := W;
       end;
    end;
    if MaxWidth > 0 then
      ListView.Columns[c].Width := MaxWidth +15
    else
      ListView.Columns[c].Width := 0;
  end;
end;

// adds a item to listview
procedure TdOPCServerStatusForm.AddItemToList(Field1, Field2: string);
var
  Item   : TListItem;
begin
  Item := ListView.Items.Add;
  Item.ImageIndex := -1;
  Item.Caption := Field1;
  Item.SubItems.Add(Field2);
end;


procedure TdOPCServerStatusForm.UpdateStatus;
var
  S : TServerStateRecord;
begin
  S := OPCClient.GetState;
  ListView.Items.BeginUpdate;
  try
    ListView.Items.Clear;
    AddItemToList('Start time',       DateTimeToStr(S.StartTime));
    AddItemToList('Current time',     DateTimeToStr(S.CurrentTime));
    AddItemToList('Last update time', DateTimeToStr((S.LastUpdateTime)));
    AddItemToList('Status info',      S.StatusInfo);
    if OPCClient is TdOPCHDAServer then
      AddItemToList('Max values',       IntToStr(S.MaxValues))
    else
      AddItemToList('Group count',       IntToStr(S.GroupCount));
    AddItemToList('Version',          S.Version);
    AddItemToList('Vendor info',      S.VendorInfo);
    AddItemToList('Server status',    HDAServerStatusToStr(S.ServerState));
  finally
    ListView.Items.EndUpdate;
  end;
end;


procedure TdOPCServerStatusForm.FormShow(Sender: TObject);
begin
   ListView.Items.Clear;
   if OPCClient <> nil then
   begin
     if OPCClient.Active then
       UpdateStatus
      else
        AddItemToList(OPCClient.ServerCaption, 'not connected');
   end
   else
     AddItemToList('no OPC server assigned', '');
  // SetColumnWidth(ListView);
end;

procedure TdOPCServerStatusForm.bUpdateClick(Sender: TObject);
begin
  UpdateStatus;
end;

end.
